@echo off
SETLOCAL

set JAVA_HOME=C:\jdk1.1.6
set SWING_HOME=C:\Swing-1.1.1
set JAXP_HOME=C:\jaxp-1.1

:check_Java
@if not exist %JAVA_HOME%\bin\java.exe goto not_found_java

:check_class
@if not exist %JAVA_HOME%\lib\classes.zip goto not_found_class
set JAVA_CLASSPATH=%JAVA_HOME%\lib\classes.zip

:check_Swing
@if not exist %SWING_HOME%\swingall.jar goto not_found_swing
set SWING_CLASSPATH=%SWING_HOME%\swingall.jar

:check_ALiCE
@if not exist .\ALiCE.jar goto not_found_ALiCE
set ALiCE_CLASSPATH=ALiCE.jar

:check_JAXP
@if not exist %JAXP_HOME%\crimson.jar goto run
@if not exist %JAXP_HOME%\jaxp.jar goto run
@if not exist %JAXP_HOME%\xalan.jar goto run
set JAXP_CLASSPATH=%JAXP_HOME%\crimson.jar;%JAXP_HOME%\jaxp.jar;%JAXP_HOME%\xalan.jar
goto run

:run
%JAVA_HOME%\bin\java -classpath .;%ALiCE_CLASSPATH%;%JAVA_CLASSPATH%;%SWING_CLASSPATH%;%JAXP_CLASSPATH% ALiCE
goto exit

:not_found_java
echo Not found '%JAVA_HOME%\bin\java.exe'
goto exit

:not_found_class
echo Not found '%JAVA_HOME%\lib\classes.zip'
goto exit

:not_found_swing
echo Not found '%SWING_HOME%\swingall.jar'
goto exit

:not_found_ALiCE
echo Not found 'ALiCE.jar'
goto exit

:exit
ENDLOCAL
