#define VC_EXTRALEAN
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

/**
 * Windows 9x/NT4.0 shutdown sample
 * @author    calico <catcall@yahoo.co.jp>
 * @url       http://www.freepage.total.co.jp/calico/index.html
 */
int main(int argc, char *argv[]) {
	/* OS ̎ނ𔻒肷 */
	// OS ̃o[W𓾂
	OSVERSIONINFO osVersion = { sizeof(OSVERSIONINFO) };
	if (!GetVersionEx(&osVersion)) {
		// o[W̎擾Ɏs
		return -1;
	}
	// OS  NT H
	if (osVersion.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		/* NT ̏ꍇAVbg_Ȅs */
		// ANZXg[N擾
		HANDLE hToken = NULL;
		if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken)) {
			// ANZXg[N̎擾Ɏs
			return -1;
		}
		// Vbg_E LUID 擾
		TOKEN_PRIVILEGES tkp = { 0 };
		if (!LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid)) {
			// LUID ̎擾Ɏs
			return -1;
		}
		// Vbg_E擾
		tkp.PrivilegeCount = 1;
		tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
		AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES) NULL, 0);
		if (GetLastError() != ERROR_SUCCESS) {
			// Vbg_E̎擾Ɏs
			// ݎsĂvZX([U)ɃVbg_E^ĂȂꍇȂ
			return -1;
		}
/*		// Vbg_Es(^CAEg܂30b)
		char *lpMachineName = NULL;
		char *lpMessage = "Stops a system shutdown after five seconds.";
		int timeout = 30;
		bool isForceAppsClosed = false;
		bool isReboot = false;
		if (!InitiateSystemShutdown(lpMachineName, lpMessage, timeout, isForceAppsClosed, isReboot)) {
			// Vbg_EɎs
			return -1;
		}
		// 5bɃVbg_E
		Sleep(5000);
		AbortSystemShutdown(lpMachineName);
*/
	}
	// dؒf
	if (ExitWindowsEx(EWX_POWEROFF, 0)) {
		return 0;
	} else {
		return -1;
	}
}
